<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.0                                                      |
// +----------------------------------------------------------------------+
// | Copyright (c) 1997, 1998, 1999, 2000, 2001 The PHP Group             |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the PHP license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at                           |
// | http://www.php.net/license/2_02.txt.                                 |
// | If you did not receive a copy of the PHP license and are unable to   |
// | obtain it through the world-wide-web, please send a note to          |
// | license@php.net so we can mail you a copy immediately.               |
// +----------------------------------------------------------------------+
// | Authors: Nishina <jj@suke.ne.jp>                                     |
// +----------------------------------------------------------------------+

// define
/**
 * ｪλη̥
 * @const JJ_BATCH_OK ｪλ
 */
define("JJ_BATCH_OK", 0);
/**
 * ۾ｪλη̥
 * @const JJ_BATCH_ERR ۾ｪλ
 */
define("JJ_BATCH_ERR", 1);

// ץ󥿥
/**
 * ץʤץ
 * @const JJ_BATCH_OPTION_TYPE_NONE_ARG ץʤ
 */
define("JJ_BATCH_OPTION_TYPE_NONE_ARG", 1);
/**
 * ץ륪ץ
 * @const JJ_BATCH_OPTION_TYPE_ARG ץ
 */
define("JJ_BATCH_OPTION_TYPE_ARG", 2);

// ץեå
/**
 * 硼ȥץեå
 * @const JJ_BATCH_PREFIX_SHORT 硼ȥץեå
 */
define("JJ_BATCH_PREFIX_SHORT", 1);
/**
 * եץեå
 * @const JJ_BATCH_PREFIX_FULL եץեå
 */
define("JJ_BATCH_PREFIX_FULL", 2);
/**
 * ǥեȥץեå-
 * @const JJ_BATCH_DEFAULT_PREFIX ǥեȥץեå
 */
define("JJ_BATCH_DEFAULT_PREFIX", "-");
/**
 * ϥեץեå-
 * @const JJ_BATCH_HYPHEN_PREFIX -ץϥեץեå
 */
define("JJ_BATCH_HYPHEN_PREFIX", "-");
/**
 * ץ饹ץեå+
 * @const JJ_BATCH_PLUS_PREFIX +ץץ饹ץեå
 */
define("JJ_BATCH_PLUS_PREFIX", "+");
/**
 * ѡȥץեå%
 * @const JJ_BATCH_PERCENT_PREFIX %ץѡȥץեå
 */
define("JJ_BATCH_PERCENT_PREFIX", "%");
/**
 * æץեå^
 * @const JJ_BATCH_OMISSION_PREFIX ^æץեå
 */
define("JJ_BATCH_OMISSION_PREFIX", "^");
/**
 * ѥɥץեå&
 * @const JJ_BATCH_AMPERSAND_PREFIX &ץѥɥץեå
 */
define("JJ_BATCH_AMPERSAND_PREFIX", "&");
/**
 * òץեå!
 * @const JJ_BATCH_EXCLAIM_PREFIX !״òץեå
 */
define("JJ_BATCH_EXCLAIM_PREFIX", "!");
/**
 * åץեå/
 * @const JJ_BATCH_SLASH_PREFIX /ץåץեå
 */
define("JJ_BATCH_SLASH_PREFIX", "/");
/**
 * ץեå˻ѲǽƤʸ
 * @const JJ_BATCH_ALL_PREFIX ץեå˻ѲǽƤʸ
 */
define("JJ_BATCH_ALL_PREFIX", "-+%^&!\/");
/**
 * ǥեȥեؿ̾
 * @const JJ_BATCH_FILE_FUNC_NAME_DEFAULT ǥեȤΥեؿ̾
 */
define("JJ_BATCH_FILE_FUNC_NAME_DEFAULT", "_file_func");

// 顼
/**
 * 顼
 * @const JJ_BATCH_ERROR_INVALID_OPTION ץ󥨥顼
 */
define("JJ_BATCH_ERROR_INVALID_OPTION", -1);

/**
 * Хå쥯饹
 *
 * @author Nishina <jj@suke.ne.jp>
 * @copyright Copyright &copy; 2003, JJ.Nishina
 * @since Rev. 1.0 - 10-23-2003
 * @version $Id: CommandBase.php,v 1.1.1.1 2003/12/13 11:04:19 jjlehto Exp $
 * @package jj_batch
 * @abstract
 */
class Batch_CommandBase
{
    /**
     * @var int $__argc ޥɥ饤ο
     */
    var $__argc;

    /**
     * @var array $__argv ޥɥ饤
     */
    var $__argv;

    /**
     * @var string $__prefix ץץեå(Default[-])
     */
    var $__prefix = JJ_BATCH_DEFAULT_PREFIX;

    /**
     * @var string $__file_func_name եѤδؿ̾ޥɥ饤ǥե̾Ϥ硢ѿ̾δؿƤФޤ
     */
    var $__file_func_name = JJ_BATCH_FILE_FUNC_NAME_DEFAULT;

    /**
     * @var array $__option_list ץ󤬳Ǽ
     */
    var $__option_list = array();

    /**
     * @var array $__called_option_list ѤߤΥץǼ
     */
    var $__called_option_list = array();

    /**
     * @var int $__current_pos ߽Υޥɥ饤ΰ
     */
    var $__current_pos = 1;

    /**
     * @var int $__option_current_pos ߽Υץΰ
     */
    var $__option_current_pos = 0;

    /**
     * @var int $__result_code ̥ɤǼƤ
     */
    var $__result_code;

    /**
     * @var object $__main_command ƤӽФοƥޥɡBatch_CommandѾ饹ǼޤƥޥɤʤnullǤ
     */
    var $__main_command;

    /**
     * @var array $__sub_command_list ƤӽФλҥޥɡKey˻ҥޥɤб᥽å̾ValueBatch_CommandѾ饹Ǽޤ
     */
    var $__sub_command_list = array();

    /**
     * 󥹥ȥ饯
     * 
     * @param int   $argc ޥɥ饤οάưŪ$_SERVER['argc']򥻥åȤ
     * @param array $argv ޥɥ饤󡣾άưŪ$_SERVER['argv']򥻥åȤ
     * @return void
     * @access public
     */
    function Batch_CommandBase($argc = null, $argv = null)
    {
        if (is_null($argc)) {
            $this->__argc = $_SERVER['argc'];
        }
        if (is_null($argv)) {
            $this->__argv = $_SERVER['argv'];
        }
    }

    /**
     * ХåMainˤʤޤΤǡѾ饹ɬС饤ɤƤ
     *
     * @return boolean true= / false=
     * @access public
     * @see __optionProcess()
     */
    function exec()
    {
        // ץ
        if (!$this->__optionProcess()) {
            $this->__result_code = JJ_BATCH_ERROR_INVALID_OPTION;
            return false;
        }

        return true;
    }

    /**
     * ޥɥ饤ޤ
     *
     * @return boolean true=ץ / false=ץ
     * @access private
     * @see __fullOptionProcess(),__shortOptionProcess(),__subOptionProcess(),__fileOptionProcess()
     * @see __shortPrefixMatch(),__fullPrefixMatch(),__userOptionCheck(),__optionArgumentCheck(),__callOptionFunction()
     */
    function __optionProcess()
    {
        // ޥɥ饤롼
        for (; $this->__current_pos < $this->__argc; $this->__current_pos++) {
            $option = $this->__argv[$this->__current_pos];    // ޥɥ饤
            $this->__setCurrentOptionPos($this->__current_pos);  // ץ֥å

            // ץ or ץ
            if ($this->__fullPrefixMatch ($option)) {
                // եץեå
                if (!$this->__fullOptionProcess($option)) {
                    return false;
                }

            } elseif ($this->__shortPrefixMatch ($option)) {
                // 硼ȥץեå
                if (!$this->__shortOptionProcess($option)) {
                    return false;
                }

            } elseif ($this->__sub_option_match ($option)) {
                // ֥ץ
                return $this->__subOptionProcess($option);

            } else {
                break;
            }
        }

        return $this->__fileOptionProcess();
    }

    /**
     * եץեåץΥå¹ԤԤޤ
     *
     * @param string $option ץ̾
     * @return boolean true=ץ / false=ץ
     * @access private
     */
    function __fullOptionProcess($option)
    {
        $func_name = "";      // ؿ̾(ץ̾)
        $func_argv = array(); // ץ

        // ץ󤫤ؿ̾
        $func_name = substr ($option, strlen($this->__prefix.$this->__prefix), strlen($option));
        
        // ץΥå
        if (!$this->__userOptionCheck($func_name, JJ_BATCH_PREFIX_FULL)) {
            return false;
        }

        // ץå
        if ($this->__optionArgumentCheck($func_name)) {
            if ($this->__current_pos+1 < $this->__argc && 
                !$this->__fullPrefixMatch ($this->__argv[$this->__current_pos+1]) && 
                !$this->__shortPrefixMatch ($this->__argv[$this->__current_pos+1]) &&
                !$this->__sub_option_match ($this->__argv[$this->__current_pos+1])) {

                // ץ˳Ǽ
                array_push ($func_argv, $this->__argv[$this->__current_pos+1]);
                $this->__nextCurrentPos(); // 
            } else {
                // ץꤵƤʤ
                return false;
            }
        }
        
        // ץؿƤ
        if (!$this->__callOptionFunction($func_name, $func_argv, JJ_BATCH_PREFIX_FULL)) {
            // ؿ¸ߤʤä
            return false;
        }

        return true;
    }
 

    /**
     * 硼ȥץեåץΥå¹ԤԤޤ
     *
     * @param string $option ץ̾
     * @return boolean true=ץ / false=ץ
     * @access private
     */
    function __shortOptionProcess($option)
    {
        $func_name = "";      // ؿ̾(ץ̾)
        $func_argv = array(); // ץ

        // ץ󤫤ؿ̾
        $func_names = substr ($option, strlen($this->__prefix), strlen($option));
        
        // ץ롼
        for ($j = 0; $j < strlen($func_names); $j++) {
            // ե󥯥̾
            $func_name = substr($func_names, $j, 1);

            // ץΥå
            if (!$this->__userOptionCheck($func_name, JJ_BATCH_PREFIX_SHORT)) {
                return false;
            }
            
            // 硼ȥץեåʣΥץƱ˻(-abc)ϡץʤ
            if (strlen($func_names) == 1) {
                // ץå
                if ($this->__optionArgumentCheck($func_name)) {
                    // 硼ȥץեåʣΥץƱ˻ꤷƤʤƥץ
                    if ($this->__current_pos+1 < $this->__argc && 
                        !$this->__fullPrefixMatch ($this->__argv[$this->__current_pos+1]) && 
                        !$this->__shortPrefixMatch ($this->__argv[$this->__current_pos+1]) && 
                        !$this->__sub_option_match ($this->__argv[$this->__current_pos+1])) {
                        
                        // ץ˳Ǽ
                        array_push ($func_argv, $this->__argv[$this->__current_pos+1]);
                        $this->__nextCurrentPos(); // 
                    } else {
                        // ץꤵƤʤ
                        return false;
                    }
                }
            } else {
                // ץå
                if ($this->__optionArgumentCheck($func_name)) {
                    // 륪ץϢ³ꤷϥ顼
                    return false;
                }
            }
            
            // ץؿƤ
            if (!$this->__callOptionFunction($func_name, $func_argv, JJ_BATCH_PREFIX_SHORT)) {
                // ؿ¸ߤʤä
                return false;
            }
        }

        return true;
    }

    /**
     * ֥ץΥå¹ԤԤޤ
     *
     * @param string $option ץ̾
     * @return boolean true=ץ / false=ץ
     * @access private
     */
    function __subOptionProcess($option)
    {
        $command = $this->getSubCommand($option);
        $command->setCommandArg($this->getSubCommandArgv());
        $command->__main_command =& $this;
        
        // ᥽åɤ򥳡
        $this->__callSubOptionFunction($option);

        return $command->exec();
    }

    /**
     * ե륪ץΥå¹ԤԤޤ
     *
     * @param string $option ץ̾
     * @return boolean true=ץ / false=ץ
     * @access private
     */
    function __fileOptionProcess()
    {
        $func_argv = array();      // ץ

        // ʹߤ˥ץ̵꤬ϥޥɥ饤fileȤɾ
        for ($i = $this->__current_pos; $i < $this->__argc; $i++ ) {
            // ץꤵƤ뤫Ĵ٤
            if ($this->__fullPrefixMatch ($this->__argv[$i]) || 
                $this->__shortPrefixMatch ($this->__argv[$i])) {
                // ץ󤬻ꤵƤХ顼
                return false;
            } else {
                // ץ˳Ǽ
                array_push ($func_argv, $this->__argv[$i]);
                $this->__nextCurrentPos(); // 
            }
        }

        // եؿ򥳡
        if (!$this->__callFileFunction($func_argv)) {
            return false;
        }

        return true;
    }

    /**
     * ץեåꤷޤ<BR>
     *
     * ʸϡ-+%&!^/פǤ<BR>
     * ˤ1ʸΤϤƤ<BR>
     * 1ʸǤʤХ顼Ȥʤޤ<BR>
     * άȡǥե(-)Υץեåꤵޤ
     * 硼ȥץեåꤵ줿ʸˤʤꡢ<BR>
     * եץեåʸ2Ҥʪˤʤޤ<BR>
     * 㤨С+פϤ줿ϡ
     * 硼ȥץեå:+<BR>
     * եץեå    :++<BR>
     * Ȥʤޤ<BR>
     *
     * @param string $short_prefix 硼ȥץեå
     * @access public
     * @see JJ_BATCH_ALL_PREFIX,JJ_BATCH_DEFAULT_PREFIX,JJ_BATCH_HYPHEN_PREFIX,JJ_BATCH_PLUS_PREFIX,JJ_BATCH_PERCENT_PREFIX
     * @see JJ_BATCH_OMISSION_PREFIX,JJ_BATCH_AMPERSAND_PREFIX,JJ_BATCH_EXCLAIM_PREFIX,JJ_BATCH_SLASH_PREFIX
     */
    function setPrefix($prefix=JJ_BATCH_DEFAULT_PREFIX) {
        if (!preg_match ("/^[".JJ_BATCH_ALL_PREFIX."]$/", $prefix)) {
            die("[CommandBase::setPrefix]ʥץեåꤵޤ\n");
        }
        $this->__prefix = $prefix;
    }

    /**
     * ץɲäޤ<BR>
     *
     * 硼ȥץեåեץեåξάǽǤɤ餫ꤷʤȥ顼Ȥʤޤ<BR>
     * ץ󥿥פάϥǥեȤJJ_BATCH_OPTION_TYPE_NONE_ARGˤʤޤ<BR>
     * ꤵ줿硼ȥץեåȥեץեåƱ쥪ץȤƴϢդޤ<BR>
     * 硼ȥץեåorեץեåꤷʤnullϤƤ<BR>
     * âɤ餫ꤷʤХ顼Ȥʤޤ
     *
     * @param string $short_opt 硼ȥץեå˻ꤹ륪ץȾѰʸΤ߻ǽ
     * @param string $full_opt  եץեå˻ꤹ륪ץ󡣰ʸʾǽ(ǥե:null)
     * @param int    $opt_type  ץΥפꡣ(ǥե:JJ_BATCH_OPTION_TYPE_NONE_ARG)
     * @return void
     * @access public
     * @see __systemOptionCheck(),JJ_BATCH_OPTION_TYPE_NONE_ARG,JJ_BATCH_OK,JJ_BATCH_ERR
     */
    function addOption($short_opt=null, $full_opt=null, $opt_type=JJ_BATCH_OPTION_TYPE_NONE_ARG)
    {
        static $co = 0;
        // ץʸå
        if (!$this->__systemOptionCheck($short_opt, $full_opt)) {
            die("[CommandBase::addOption]ʥץɲäޤ\n");
        }
        $this->__option_list[$co]['short_option'] = $short_opt;
        $this->__option_list[$co]['full_option']  = $full_opt;
        $this->__option_list[$co]['option_type']  = $opt_type;
        $co++;
    }

    /**
     * եѴؿ̾ꤷޤ<BR>
     *
     * @param  string $func_file_name եؿ̾(ǥե:_func_file)
     * @return void
     * @access public
     */
    function setFuncFileName($func_file_name=JJ_BATCH_FILE_FUNC_NAME_DEFAULT)
    {
        $this->__file_func_name = $func_file_name;
    }

    /**
     * ǻꤵ줿ե󥯥򥳡뤷ޤ<BR>
     *
     * ˻ꤵ줿ؿ̾δؿƤִؿ<BR>
     * ϴؿΰȤϤޤ
     *
     * @param  string  $func_name ؿ̾
     * @param  array   $func_argv ؿ
     * @param  int     $prefix   硼ȥץեåorեץեå
     * @return boolean true=ؿƤӽФ / false=ؿƤӽФ
     * @access private
     */
    function __callOptionFunction($func_name, $func_argv, $prefix)
    {
        // ؿ̾Ϣץ
        foreach ($this->__option_list as $option) {
            if ($prefix == JJ_BATCH_PREFIX_FULL && $option['full_option'] == $func_name) {
                if (!method_exists ($this, $func_name)) {
                    $func_name = $option['short_option'];
                }
                $full_func_name  = $option['full_option'];
                $short_func_name = $option['short_option'];
                break;
            }
            if ($prefix == JJ_BATCH_PREFIX_SHORT && $option['short_option'] == $func_name) {
                if (!method_exists ($this, $func_name)) {
                    $func_name = $option['full_option'];
                }
                $full_func_name  = $option['full_option'];
                $short_func_name = $option['short_option'];
                break;
            }
        }

        // Ʊ쥪ץ󡢴Ϣץ󤬥뤵Ƥ뤫
        if (!in_array($full_func_name, $this->__called_option_list) && 
            !in_array($short_func_name, $this->__called_option_list)) {
            // ѤߥꥹȤɲ
            array_push($this->__called_option_list, $func_name);
        } else {
            // Ʊ쥪ץ󤬣󥳡뤵줿
            return false;
        }

        // ץбؿƤ
        if (!is_null($func_argv) && count($func_argv)) {
            $this->$func_name($func_argv);
        } else {
            $this->$func_name();
        }
        return true;

    }

    /**
     * ǻꤵ줿֥ץ̾бؿ򥳡뤷ޤ<BR>
     *
     * @param string $func_name ץ̾
     * @private
     */
    function __callSubOptionFunction($func_name)
    {
        // եؿƤ뤫
        if (method_exists ($this, $func_name)) {
            // եؿƤ
            $this->{$func_name}(); 
        }
    }

    /**
     * եؿ򥳡뤷ޤ<BR>
     * եؿΰȤϤޤ
     *
     * @param array $func_argv ե̾
     * @return boolean true=եؿ/false=եؿ뼺
     * @private
     */
    function __callFileFunction($func_argv)
    {
        // եؿƤ뤫
        if (method_exists ($this, $this->__file_func_name)) {
            // եؿƤ
            $this->{$this->__file_func_name}($func_argv); 
        } else {
            if (count($func_argv) > 0) {
                // եؿƤʤƥץϥ顼
                return false;
            }
        }
        return true;
    }

    /**
     * 硼ȥץեåޤޤ뤫Ĵ٤<BR>
     *
     * @param  string  $opt ץ
     * @return boolean true=硼ȥץեåޤޤ롣/ false=硼ȥץեåޤޤʤ
     * @access private
     */
    function __shortPrefixMatch($opt)
    {
        return preg_match ("/^\\".$this->__prefix.".+$/", $opt);
    }

    /**
     * եץեåޤޤ뤫Ĵ٤<BR>
     *
     * @param  string  $opt ץ
     * @return boolean true=եץեåޤޤ롣/ false=եץեåޤޤʤ
     * @access private
     */
    function __fullPrefixMatch($opt)
    {
        return preg_match ("/^\\".$this->__prefix."\\".$this->__prefix.".+$/", $opt);
    }

    /**
     * addOption줿ץåޤ
     *
     * @param string  $short_opt 硼ȥץեå˻ꤹ륪ץȾѰʸΤ߻ǽ
     * @param string  $full_opt  եץեå˻ꤹ륪ץ󡣰ʸʾǽ
     * @return boolean true= / false=顼
     * @access private
     * @see __optionCharCheck(),__optionDuplicationCheck()
     */
    function __systemOptionCheck($short_opt, $full_opt)
    {
        // ץ̾å
        if (!$this->__optionCharCheck($short_opt, $full_opt)) {
            return false;
        }

        // ʣå
        return $this->__optionDuplicationCheck($short_opt, $full_opt);
    }

    /**
     * ץ̾åޤ
     *
     * @param string  $short_opt 硼ȥץեå˻ꤹ륪ץȾѰʸΤ߻ǽʥǥե:null
     * @param string  $full_opt  եץեå˻ꤹ륪ץ󡣰ʸʾǽ(ǥե:null)
     * @return boolean true=ʥץ̾ / false=ʥץ̾
     * @access private
     */
    function __optionCharCheck($short_opt=null, $full_opt=null)
    {
        // 硼ȥץեååȾѱѿ1ʸ
        if (!is_null($short_opt) && 
            !preg_match ("/^[0-9a-zA-Z]$/", $short_opt)) {
            return false;
        }
        // եץեååȾѱѿ,=[]2ʸʾ
        if (!is_null($full_opt) && 
            !preg_match ("/^[0-9a-zA-Z=]{2,}$/", $full_opt)) {
            return false;
        }
        return true;
    }

    /**
     * ץνʣåޤ
     *
     * @param string  $short_opt 硼ȥץեå˻ꤹ륪ץȾѰʸΤ߻ǽ
     * @param string  $full_opt  եץեå˻ꤹ륪ץ󡣰ʸʾǽ
     * @return boolean true=ʣ̵ / false=ʣͭ
     * @access private
     */
    function __optionDuplicationCheck($short_opt, $full_opt)
    {
        if (is_null($short_opt) && is_null($full_opt)) {
            return false;
        }
        if ($short_opt == $full_opt) {
            return false;
        }

        // ʣå
        foreach ($this->__option_list as $option_info) {
            if (!is_null($full_opt) && 
                $option_info['full_option']  == $full_opt) {
                return false;
            }
            if (!is_null($short_opt) && 
                $option_info['short_option'] == $short_opt) {
                return false;
            }
        }

        return true;
    }

    /**
     * 桼Ϥץ狼åޤ
     *
     * @param  string  $func_name ץ̾
     * @param  int     $prefix   硼ȥץեåorեץեå
     * @return boolean true=ʥץ󤬻ꤵƤ롣/ false ʥץ󤬻ꤵƤ롣
     * @access private
     * @see __optionCharCheck()
     */
    function __userOptionCheck($func_name, $prefix)
    {
        // ꤵ줿ץݻ
        static $func_name_list = array();
        // ץ̾å
        if ($prefix == JJ_BATCH_PREFIX_SHORT) {
            if (!$this->__optionCharCheck($func_name)) {
                return false;
            }
        } elseif ($prefix == JJ_BATCH_PREFIX_FULL) {
            if (!$this->__optionCharCheck(null,$func_name)) {
                return false;
            }
        } else {
            return false;
        }

        // ץƤ뤫å
        $key = null;
        for ($i = 0; $i < count($this->__option_list); $i++) {
            if ($this->__option_list[$i]['short_option'] == $func_name ||
                $this->__option_list[$i]['full_option'] == $func_name) {
                $key = $i;
                break;
            }
        }
        if (is_null($key)) {
            return false;
        }

        // Ʊ쥪ץ󤬻ꤵƤʤå
        if (!in_array($func_name, $func_name_list)) {
            array_push ($func_name_list, $func_name);
        } else {
            return false;
        }

        return true;
    }

    /**
     * Υץ󤬰뤫å
     *
     * @param  string  $func_name    ץ̾
     * @return boolean true ץͭ/ false ץ̵
     * @access private
     * @see JJ_BATCH_OPTION_TYPE_NONE_ARG
     */
    function __optionArgumentCheck($func_name)
    {
        // ץ󥿥פμ
        foreach ($this->__option_list as $option) {
            if ($option['short_option'] == $func_name || $option['full_option'] == $func_name) {
                if ($option['option_type'] == JJ_BATCH_OPTION_TYPE_NONE_ARG) {
                    // Ȥʤץ
                    return false;
                } elseif ($option['option_type'] == JJ_BATCH_OPTION_TYPE_ARG) {
                    // Ȥʤץ
                    return true;
                }
            }
        }

        return false;
    }

    /**
     * ֥ޥɰܹԤΥץ֤
     *
     * @param array $sub_argv ֥ޥɰܹԤΥץ
     * @access public
     */
    function getSubCommandArgv()
    {
        $sub_argv = array();
        for ($i = $this->__option_current_pos; $i < count($this->__argv); $i++) {
            array_push($sub_argv, $this->__argv[$i]);
        }
        return $sub_argv;
    }

    /**
     * ֥ޥɤȤΥ֥ޥɤб᥽å̾ꤷޤ
     *
     * @param string $name ֥ޥɤбؿ̾&ץ̾
     * @param object $command ֥ޥɤΥ֥ȡBatch_CommandBaseѾ饹
     * @access public
     */
    function setSubCommand($name, $command)
    {
        $this->__sub_command_list[$name] =& $command;
    }

    /**
     * ֥ޥɤδؿ֤̾ޤ
     *
     * @param string $name ֥ޥɤбؿ̾&ץ̾
     * @access public
     */
    function &getSubCommand($name)
    {
        return $this->__sub_command_list[$name];
    }

    /**
     * ƥޥɤΥ֥Ȥꤷޤ
     * ֥ȤBatch_CommandBaseѾ饹
     *
     * @param object $main_command ƥޥɤΥ֥ȡ
     * @access public
     */
    function setMainCommand($main_command)
    {
        $this->__main_command =& $main_command;
    }

    /**
     * ƥޥɤΥ֥Ȥ֤ޤ
     * ֥ȤBatch_CommandBaseѾ饹
     *
     * @return object ƥޥɤΥ֥ȡ
     * @access public
     */
    function &getMainCommand()
    {
        return $this->__main_command;
    }

    /**
     * ֥ץ̾Ĵ٤<BR>
     *
     * @param  string  $opt ץ
     * @return boolean true=硼ȥץեåޤޤ롣/ false=硼ȥץեåޤޤʤ
     * @access private
     */
    function __sub_option_match($opt)
    {
        return array_key_exists($opt, $this->__sub_command_list);
    }

    /**
     * ޥɥ饤򥻥åȤޤ<BR>
     * ޥɥ饤ο⼫ưŪ˥åȤޤ
     *
     * @param array $argv ޥɥ饤
     * @access public
     */
    function setCommandArg($argv)
    {
        $this->__argv = $argv;
        $this->__argc = count($argv);
    }

    /**
     * ߽Υޥɥ饤ΰ֡
     * ϤޤäƤʤ0֤ޤ
     * ξ1֤ޤ
     * 
     * @return int ߽Υץΰ
     * @access public
     */
    function getCurrentPos()
    {
        return $this->__current_pos;
    }

    /**
     * ߽Υޥɥ饤ΰ֤򣱰ưޤ(+1)
     *
     * @return void
     * @access private
     */
    function __nextCurrentPos()
    {
        $this->__current_pos++;
    }

    /**
     * ߽Υץ֤̾ޤ
     * ϤޤäƤʤ϶ʸ֤ޤ
     * 
     * @return string ߽Υץ̾
     * @access public
     */
    function getCurrentOptionName()
    {
        if ($this->__option_current_pos <= 0) {
            return "";
        }
        return $this->__argv[$this->__option_current_pos];
    }

    /**
     * ߽Υץΰ֡
     * ϤޤäƤʤ0֤ޤ
     * 쥪ץ󤬽ξ1֤ޤ
     * 
     * @return int ߽Υץΰ
     * @access public
     */
    function getCurrentOptionPos()
    {
        return $this->__option_current_pos;
    }

    /**
     * ߽Υץΰ֤򣱰ưޤ(+1)
     *
     * @return void
     * @access private
     */
    function __nextCurrentOptionPos()
    {
        $this->__option_current_pos++;
    }

    /**
     * ߽Υץΰ֤ꤷޤ
     *
     * @param int $pos ꤷץ
     * @return void
     * @access private
     */
    function __setCurrentOptionPos($pos)
    {
        $this->__option_current_pos = $pos;
    }

    /**
     * ̥å֤ޤ
     *
     * @return string ̥å
     * @access public
     */
    function getMessage()
    {
        $msg = null;
        switch ($this->__result_code) {
        case JJ_BATCH_ERROR_INVALID_OPTION: 
            $msg = "ʥץ󤬻ꤵޤ";
            break;
        default:
            $msg = "unKnown";
        }
        return $msg;
    }

    /**
     * ͤǥեޥåȤusageʸ֤ޤ
     *
     * @param string $cmd_name ޥ̾
     * @param string $option   ץλˡ
     * @param string $cmd_help ޥɤ
     * @param string $option_help ץ
     * @param string $note 
     * @return string եޥåȤ줿usageʸ
     * @access public
     */
    function getUsage($cmd_name = "command", $option = "[options]...", $cmd_help = "command help", $option_help = "option help", $note = "note")
    {

// usageƥץ졼
$usage = <<<EOD
usage: %cmd_name% %option%
%cmd_help%

%option_help%

%note%

EOD;
        $usage = preg_replace("/%cmd_name%/",    $cmd_name,    $usage);
        $usage = preg_replace("/%option%/",      $option,      $usage);
        $usage = preg_replace("/%cmd_help%/",    $cmd_help,    $usage);
        $usage = preg_replace("/%option_help%/", $option_help, $usage);
        $usage = preg_replace("/%note%/",        $note,        $usage);

        return $usage;
    }

    /**
     * ͤǥեޥåȤusageʸɽޤ
     *
     * @param string $cmd_name ޥ̾
     * @param string $option   ץλˡ
     * @param string $cmd_help ޥɤ
     * @param string $option_help ץ
     * @param string $note 
     * @access public
     */
    function showUsage($cmd_name = "command", $option = "[options]...", $cmd_help = "command help", $option_help = "option help", $note = "note")
    {
        print $this->getUsage($cmd_name, $option, $cmd_help, $option_help, $note);
    }
}


?>