<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP version 4.0                                                      |
// +----------------------------------------------------------------------+
// | Copyright (c) 1997, 1998, 1999, 2000, 2001 The PHP Group             |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the PHP license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at                           |
// | http://www.php.net/license/2_02.txt.                                 |
// | If you did not receive a copy of the PHP license and are unable to   |
// | obtain it through the world-wide-web, please send a note to          |
// | license@php.net so we can mail you a copy immediately.               |
// +----------------------------------------------------------------------+
// | Authors: Nishina <jj@suke.ne.jp>                                     |
// +----------------------------------------------------------------------+

// define
/**
 * ϥ
 * @const JJ_BATCH_DATE 
 */
define("JJ_BATCH_DATE", 0);

/**
 * ϥ
 * @const JJ_BATCH_NUMBER 
 */
define("JJ_BATCH_NUMBER", 1);

/**
 * ϥ饹
 *
 * @author Nishina <jj@suke.ne.jp>
 * @copyright Copyright &copy; 2003, JJ.Nishina
 * @since Rev. 1.0 - 10-23-2003
 * @version $Id: Output.php,v 1.1.1.1 2003/12/13 11:04:19 jjlehto Exp $
 * @package jj_util
 */
class Util_Output
{
    /**
     * @var string $__start 
     */
    var $__start;

    /**
     * @var string $__end λ
     */
    var $__end;

    /**
     * @var string $__interval ϴֳ
     */
    var $__interval;

    /**
     * @var intager $__mode ⡼
     */
    var $__mode;

    /**
     * @var intager $__current_pos ߤΰ
     */
    var $__current_pos = 0;

    /**
     * @var array $__all_data ϥǡ
     */
    var $__all_data = array();

    /**
     * 󥹥ȥ饯
     * 
     * @param string 
     * @param string λ
     * @param intager ϥ
     * @param string ϴֳ
     * @return void
     * @access public
     */
    function Util_Output ($start, $end, $mode, $interval = 1)
    {
        $this->__start    = $start;
        $this->__end      = $end;
        $this->__mode     = $mode;
        $this->__interval = $interval;
        $this->__setArrayData();
    }

    /**
     * ͤ˳Ǽޤ
     * 
     * @return void
     * @access private
     */
    function __setArrayData ()
    {
        switch ($this->__mode) {
        case JJ_BATCH_DATE:
            $date = $this->__start;
            while (($date = $this->__nextDate($date)) <= $this->__end) {
                array_push ($this->__all_data, $date);
            }
            break;
        case JJ_BATCH_NUMBER:
            for ($num = $this->__start; $num <= $this->__end; $num++) {
                array_push ($this->__all_data, $num);
            }
            break;
        }
    }

    /**
     * ǻꤷդꤷֳ­դ֤ޤ
     * 
     * @param $string о
     * @return ǻꤷդꤷֳ­
     * @access private
     */
    function __nextDate ($date)
    {
        return date("Y-m-d", strtotime("+{$this->__interval} day", strtotime($date)));
    }

    /**
     * ͤǶڤɽޤ
     * 
     * @param $string ͤͤδ֤ڤʸꤷޤ
     * @return Ƥν
     * @access public
     */
    function printAll ($br = "<BR>")
    {
        foreach ($this->__all_data as $data) {
            echo $data."$br";
        }
    }

    /**
     * νͤ¸ߤ뤫Ƚꤷޤ
     * 
     * @return boolean true=νͤ / false=ν̵ͤ
     * @access public
     */
    function hasNext ()
    {
        return isset($this->__all_data[$this->__current_pos]);
    }

    /**
     * ν֤ͤޤ
     * ν̵ͤnull֤ޤ
     * 
     * @return string ν
     * @access public
     */
    function next ()
    {
        $ret = null;

        if ($this->hasNext()) {
            $ret = $this->__all_data[$this->__current_pos];
            $this->__current_pos++;
        }

        return $ret;
    }

    /**
     * ϰ֤ѹޤ
     * 
     * @param integer $pos ϰ
     * @access public
     */
    function setPos ($pos)
    {
        $this->__current_pos = $pos;
    }
}

?>